; *******************************************************
; *							*
; *     Play music on Adlib sound card                  *
; *	                                         	*
; *     Code by PSI                                     *
; *	Music by Scaven/FC                              *
; *     Converted to OBJ format by The GodFather        *
; *							*
; *******************************************************
                
CODE    SEGMENT WORD PUBLIC


        ASSUME  CS:CODE,DS:CODE


; Publics
        PUBLIC  InitAdlib
        PUBLIC  PlayMusic


;---------------------------------------------------------------------------
;
;                        Initialize Adlib sound card
;
;---------------------------------------------------------------------------
InitAdlib:
        PUSH    BP
        PUSH    DS
        MOV     AX, CS
        MOV     DS, AX
        
        mov     ax, 00120h
        call    A_OutAw
        mov     ax, 00800h
        call    A_OutAw
        mov     ah, 0bdh
        call    A_OutAw
        mov     bp, 9
        xor     bx, bx
        mov     di, OFFSET Music_Instruments

 ResetInstruments:
        mov     si, ds:[di]
        add     di, 2
        call    A_LoadInstrument
        xor     ax, ax
        call    A_PlayNote
        inc     bx
        dec     bp
        jnz     ResetInstruments


        POP     DS
        POP     BP
        RETF





;---------------------------------------------------------------------------
;
;                          Play a note from music
;
;---------------------------------------------------------------------------

; Must be called 60 times per second. The perfect
; solution is to be called after a Vertical Retrace.
; --------------------------------------------------
PlayMusic:
        PUSH    BP
        PUSH    DS
        MOV     AX, CS
        MOV     DS, AX

        SUB     DS:A_MusicCnt, 1
        JNC     AP_Exit

        mov     ds:A_MusicCnt, Music_Speed
        mov     cx, Music_Channels
        mov     di, OFFSET Music_Patterns
        xor     bx, bx
        
 A1:    sub     ds:a_chdelaycnt[bx], 1
        jns     @@2
        mov     si, ds:[di]
        xor     ax, ax
        call    A_PlayNote
        
@@4:    lodsb
        or      al, al
        jz      @@7
        jns     @@6
        sub     al, 81h
        mov     ds:a_chdelay[bx], al
        lodsb
@@6:    mov     dl, al
        and     ax, 15
        mov     bp, ax
        add     bp, bp
        mov     ax, ds:a_note_table[bp]
        shr     dl, 2
        and     dl, not 3
        add     ah, dl
        call    A_PlayNote
        mov     al, ds:a_chdelay[bx]
        mov     ds:a_chdelaycnt[bx], al
        mov     ds:[di], si
        
  @@2:  add     di, 4
        inc     bx
        loop    A1

 AP_Exit:
        POP     DS
        POP     BP
        RETF

 @@7:   MOV     SI, DS:[DI+2]
        JMP     @@4

        POP     DS
        POP     BP
        RETF        
                    
                    

    

;---------------------------------------------------------------------------
;
;                    SubRoutines used by INITADLIB, PLAYMUSIC
;                          
;---------------------------------------------------------------------------
A_Wait  PROC NEAR       ;CX=Delay, DX=Port
        in      al, dx
        loop    a_wait
        ret
A_Wait  ENDP



A_OutAw PROC NEAR       ;AH=Reg, AL=Data
        push    ax
        push    cx
        xchg    al, ah
        mov     dx, 388h
        out     dx, al
        mov     cx, 7
        call    A_Wait
        mov     dx, 389h
        mov     al, ah
        out     dx, al
        mov     cx, 30
        call    A_Wait
        pop     cx
        pop     ax
        RET
A_OutAw ENDP

                      

A_LodsbOutAw PROC NEAR
        LODSB
        CALL    A_OutAw
        RET
A_LodsbOutAw    ENDP


                            
A_LodsbOutAw03 PROC NEAR
        CALL    A_LodsbOutAw
        ADD     AH, 3
        CALL    A_LodsbOutAw
        RET
A_LodsbOutAw03 ENDP




A_LoadInstrument PROC NEAR
        mov     ah, DS:A_Inst_Table[BX]
        mov     cx, 4
 @@1:   call    A_LodsbOutAw03
        add     ah, 20h-3
        loop    @@1
        add     ah, 40h
        call    A_LodsbOutAw03
        mov     ah, BL
        add     ah, 0C0h
        CALL     A_LodsbOutAw
        RET
A_LoadInstrument ENDP
                     

                     
                     
A_PlayNote PROC NEAR
        push    bx
        xchg    ah, bl
        add     ah, 0A0h
        call    A_OutAw 
        mov     al, bl
        add     ah, 010h
        pop     bx
        CALL    A_OutAw
        RET
A_PlayNote ENDP




;---------------------------------------------------------------------------
;                            
;                         Variables & typed constants
;                              
;---------------------------------------------------------------------------
A_MusicCnt      DW      1
A_ChDelaycnt    DB      9 DUP(0)
A_ChDelay       DB      9 DUP(0)

;ALIGN 2
A_Inst_Table LABEL BYTE
                DB      20h+0
                DB      20h+1
                DB      20h+2
                DB      20h+8
                DB      20h+9 
                DB      20h+10
                DB      20h+16
                DB      20h+17
                DB      20h+18
                             
                             
NTB             EQU     8192

A_Note_Table LABEL WORD                                                
                DW      NTB+363,NTB+385,NTB+408,NTB+432,NTB+458,NTB+485
                DW      NTB+514,NTB+544,NTB+577,NTB+611,NTB+647,NTB+868


; ################### Music - (Tune by Skaven/FC) ####################
; Generated with ST3 -> SIMPLEXADLIB, handoptimized by PSI (283 bytes)
Music_Channels    EQU 8
Music_Speed       EQU 8
Music_Instruments LABEL BYTE
                        DW OFFSET Ains6
                        DW OFFSET Ains2
                        DW OFFSET Ains4
                        DW OFFSET Ains3
                        DW OFFSET Ains3
                        DW OFFSET Ains1
                        DW OFFSET Ains1
                        DW OFFSET Ains4
        Ains1 LABEL BYTE
                DB 065,194,006,000,035,242,240,240,001,000,004
        Ains2 LABEL BYTE
                DB 145,064,135,128,243,111,035,003,001,001,002
        Ains3 LABEL BYTE
                DB 225,033,017,128,017,019,034,034,000,000,012
        Ains4 LABEL BYTE
                DB 097,033,027,000,098,132,086,085,000,000,014
        Ains6 LABEL BYTE
                DB 145,064,135,136,243,111,035,003,001,001,002


Music_Patterns LABEL BYTE
                Ach0 DW OFFSET Ach0d, OFFSET Ach0d
                Ach1 DW OFFSET Ach1d, OFFSET Ach1d
                Ach2 DW OFFSET Ach2d, OFFSET Ach2d
                Ach3 DW OFFSET Ach3d, OFFSET Ach3d
                Ach4 DW OFFSET Ach4d, OFFSET Ach4d
                Ach5 DW OFFSET Ach5d, OFFSET Ach5d
                Ach6 DW OFFSET Ach6d, OFFSET Ach6d
                Ach7 DW OFFSET Ach7d, OFFSET Ach7d
        Ach0d LABEL BYTE
                DB 057h,050h,050h,055h,057h,050h,055h,057h
                DB 050h,055h,057h,050h,055h,057h,050h,055h
                DB 000h
        Ach1d LABEL BYTE
                DB 050h,055h,057h,050h,055h,057h,050h,055h
                DB 057h,050h,055h,057h,050h,055h,057h,050h
                DB 000h
        Ach2d LABEL BYTE
                DB 0C0h,050h,084h
                DB 030h,020h,030h,020h,02Ah,01Ah,02Ah,01Ah
                DB 030h,020h,030h,020h,02Ah,01Ah,02Ah,01Ah
        Ach2dr LABEL BYTE
                DB 030h,020h,030h,020h,02Ah,01Ah,02Ah,01Ah
                DB 025h,015h,025h,015h,028h,018h,02Ah,01Ah
                DB 000h
        Ach3d LABEL BYTE
                DB 0A0h,050h,040h,0C0h,040h,088h,040h,040h
                DB 03Ah,042h,090h,045h,088h,040h,042h,040h
                DB 047h,090h,04Ah,088h,045h,098h,040h
                DB 000h
        Ach4d LABEL BYTE
                DB 0A0h,050h,030h,0C0h,047h,088h,047h,043h
                DB 042h,045h,047h,045h,048h,047h,047h,050h
                DB 052h,084h,050h,04Ah,088h,050h,098h,045h
                DB 000h 
        Ach5d LABEL BYTE
                DB 0C0h,020h,0A0h,010h,010h,090h,010h,02Ah
                DB 025h,088h,028h,02Ah,090h,010h,02Ah,025h
                DB 088h,028h,02Ah
                DB 000h
        Ach6d LABEL BYTE
                DB 0C0h,020h,0A0h,020h,020h,090h,020h,01Ah
                DB 015h,088h,018h,01Ah,090h,020h,01Ah,015h
                DB 088h,018h,01Ah
                DB 000h
        Ach7d LABEL BYTE
                DB 0C0h,00Ch,0FEh,050h,090h,00Ch,081h,04Ah
                DB 050h,084h,052h,055h,086h,04Ah,081h,050h
                DB 04Ah,086h,050h,082h,055h,098h,045h
                DB 000h
;---------------------------------------------------------------------------


CODE    ENDS

        END
